unit hiCheckBox;

interface

uses Windows,Kol,Share,Win;

{$I share.inc}

type
  THICheckBox = class(THIWin)
   private
     procedure _OnClick(Obj:PObj);
     procedure SetCaption(const Value:string);
     procedure SetChecked(Value:byte);
   public
    _event_onCheck:THI_Event;
    _event_onClick:THI_Event;

    constructor Create(Parent:PControl);
    procedure Init; override;
    procedure _work_doCheck(var _Data:TData; Index:word);
    procedure _work_doCaption(var _Data:TData; Index:word);
    procedure _var_Checked(var _Data:TData; Index:word);
    property _prop_Checked:byte write SetChecked;
    property _prop_Caption:string write SetCaption;
  end;

implementation

constructor THICheckBox.Create;
begin
   inherited Create(Parent);
   Control := NewCheckbox(Parent,'CheckBox');
   Control.OnClick := _OnClick;
end;

procedure THICheckBox.Init;
var   dt:TData;
begin
   inherited;
   if Assigned(_prop_SavePropManager) then begin
      dtNull(dt);
      dt := _prop_SavePropManager.sprop('Checked', dt, false);
      if not _IsNull(dt) then Control.Checked := boolean(ToInteger(dt));
      dt := _prop_SavePropManager.sprop('Caption', dt, false);
      if not _IsNull(dt) then Control.Caption := ToString(dt);
   end;
end;   

procedure THICheckBox._work_doCheck;
var   dt:TData;
begin
   Control.Checked := ReadBool(_Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, byte(Control.Checked));
      _prop_SavePropManager.sprop('Checked', dt, true);
   end;
   _hi_onEvent(_event_onCheck,byte(Control.Checked));
end;

procedure THICheckBox._work_doCaption;
var   dt:TData;
begin
   Control.Caption := ToString(_Data);
   if Assigned(_prop_SavePropManager) then begin
      dtString(dt, Control.Caption);
      _prop_SavePropManager.sprop('Caption', dt, true);
   end;
end;

procedure THICheckBox._var_Checked;
begin
   dtInteger(_Data,integer(Control.Checked));
end;

procedure THICheckBox.SetCaption;
begin
   Control.Caption := Value;
end;

procedure THICheckBox.SetChecked;
begin
   Control.Checked := Value = 0;
end;

procedure THICheckBox._OnClick;
var   dt:TData;
begin
   _hi_onEvent(_event_onCheck,byte(Control.Checked ));
   _hi_onEvent(_event_onClick,byte(Control.Checked ));
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, byte(Control.Checked));
      _prop_SavePropManager.sprop('Checked', dt, true);
   end;
end;

end.
