unit hiSavePropManager;

interface
     
uses Messages,Windows,Kol,Share,Debug;

type
  TISavePropManager = record
    init:  procedure of object;
    sprop: function(Parametr: string; Value:TData; State:boolean):TData of object;
  end;
  PTOOLINFO = ^TTOOLINFO;
  ISavePropManager = ^TISavePropManager;
  THISavePropManager = class(TDebug)
   private
     spm:TISavePropManager;
     SList:PStrList;
     procedure init;
     function None(Parametr: string; Value:TData; State:boolean):TData;
     function Registry(Parametr: string; Value:TData; State:boolean):TData;
     function IniFile(Parametr: string; Value:TData; State:boolean):TData;
     
   public                   

     _prop_FileName:string;
     _prop_Name:string;
     _prop_ListProp:string;

     constructor Create;
     destructor Destroy; override;
     function getInterfaceSaveProp:ISavePropManager;
  end;

implementation

constructor THISavePropManager.Create;
begin
   inherited;
   SList := NewStrList;
   spm.init  := init;
end;

destructor THISavePropManager.Destroy;
begin
   SList.free;
   inherited;
end;   

function THISavePropManager.getInterfaceSaveProp;
begin
   Result := @spm;
end;

procedure THISavePropManager.init;
begin
   SList.Text := _prop_ListProp;
   if _prop_FileName = '' then
      spm.sprop := None
   else if Pos('.ini', _prop_FileName) = 0 then
      spm.sprop := Registry
   else spm.sprop := IniFile;
end;

function THISavePropManager.None;
begin
end;

function THISavePropManager.Registry;
var   pkey: HKey;
      DataType: DWORD;
      Disposition, tmp: Integer;
      str: string;
      key: string;
      i: integer;
      Found: boolean;
      BufSize: Integer;
begin
   dtNull(Result);
   Found := false;
   for i := 0 to SList.Count - 1 do begin
      if LowerCase(Parametr) = LowerCase(SList.Items[i]) then begin
         Found := true;
         break; 
      end;
   end; 
   if not Found then exit;

   key := 'Software\' + _prop_FileName + '\' + _prop_Name;

   if State then begin
      if RegCreateKeyEx(HKEY_CURRENT_USER,PChar(key), 0, nil,
                        REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, nil, pkey, @Disposition) = ERROR_SUCCESS then begin
         if _IsInteger(Value) then begin
            tmp := ToInteger(Value);
            RegSetValueEx(pkey, PChar(Parametr),  0, REG_DWORD, @tmp, SizeOf(Integer));
         end else if _IsStr(Value) then begin
            str := ToString(Value);
            RegSetValueEx(pkey, PChar(Parametr),  0, REG_EXPAND_SZ, @str[1], Length(str));
         end;
        RegCloseKey(pkey);
      end;
   end else begin
      if RegOpenKeyEx(HKEY_CURRENT_USER,PChar(key), 0, KEY_READ, pkey) = ERROR_SUCCESS then begin
         DataType := REG_NONE;
         BufSize := 0;
         RegQueryValueEx(pkey, PChar(Parametr), nil, @DataType, nil, @BufSize);
         if DataType = REG_DWORD then begin
            if RegQueryValueEx(pkey, PChar(Parametr), nil, @DataType, PByte(@tmp),
                               @BufSize) = ERROR_SUCCESS then dtInteger(Result, tmp) 
         end else if DataType = REG_EXPAND_SZ then begin
            SetLength(str,BufSize);
            if RegQueryValueEx(pkey, PChar(Parametr), nil, @DataType, PByte(@str[1]),
                               @BufSize) = ERROR_SUCCESS then dtString(Result, str);
         end;
         RegCloseKey(pkey);
      end;
   end;
end;

function THISavePropManager.IniFile;
var   Ini:PIniFile; p:integer;
      str: string;
      i: integer;
      Found: boolean;
begin
   dtNull(Result);
   Found := false;
   for i := 0 to SList.Count - 1 do begin
      if LowerCase(Parametr) = LowerCase(SList.Items[i]) then begin
         Found := true;
         break; 
      end;
   end; 
   if not Found then exit;

   p := Pos('.ini\', _prop_FileName + '\' + _prop_Name);
   Ini := OpenIniFile(GetStartDir + Copy(_prop_FileName + '\' + _prop_Name, 1, p+3));
   Ini.Section := _prop_Name;

   if State then begin
      Ini.Mode := ifmWrite;
      if _IsInteger(Value) then
         Ini.ValueString(Parametr, int2str(ToInteger(Value)))
      else if _IsStr(Value) then
         Ini.ValueString(Parametr, ToString(Value));
   end else begin
      Ini.Mode := ifmRead;
      str := '';
      str := Ini.ValueString(Parametr, str);
      if str <> '' then dtString(Result, str); 
   end;
   Ini.Free;
end;


end.